/*
Gzegoz, Jurgo , 2 kursas, 8 grupe, 1 uzduotis
deletas veikia pagal hasha, reik irasyt zodi is hasho.
is red-black tree trinama yra tik logiskai 
*/
#include <iostream>
#include <fstream>
struct hash{
            int line;
            std::string name;
            struct hash *kitas;
           };

struct rbTree{
              int key;
              int line;
              std::string name; 
              int spalva;
              int trinimas;
              struct rbTree *kaire;
              struct rbTree *desine;
              struct rbTree *tevas;
              struct rbTree *nil;
             };
int  h_key(char*,int);
void h_sukurti(struct hash**,int);
void h_terpti(struct hash**,int,int,std::string);
void h_spausdinti(struct hash ** ,int);
void h_ieskoti(struct hash**,char*,int);
void f_eilute(int);
int  t_key(char*);
void t_terpti(struct rbTree *);
void t_desinysPosukis(struct rbTree *);
void t_kairysPosukis(struct rbTree *);
void t_sukeist(struct rbTree *);
void inorder(struct rbTree *);
void t_search(struct rbTree *,int,int);
void t_delete(struct rbTree *,int,int);
int  h_trinti(struct hash **,char *,int);
void insert(char*,int,int,struct hash**,int);
void f_getgatve(int);
void f_write(int line);
static struct rbTree* root=NULL;	
using namespace std;
//*****************************************
main(int argc, char **argv)
{
 struct hash**  hashas=NULL;

 struct rbTree *laikinas;
 char *word,*kazkas;
 char a;
 char oneline[100];
 int i=0,didumas=20,key=0,linne=1,line=1,n=0,length,sk,skk;
 char *sh="sh",*st="st",*ph="ph",*pt="pt",*ins="i",*d="d";
 ifstream fin("telephone.dat");
 hashas=new struct hash*[didumas];
 for(n=0;n<didumas;n++)
  hashas[n]=NULL;
 while(fin.good()) 
  {
   word =(char *) calloc(40, sizeof(int));
   while((a=fin.get())!=',')
   {
   word[i]=a;
   i++;
   }
   key=h_key(word,didumas);
   h_terpti(hashas,key,linne,word);
   linne++;
   fin.getline(oneline,100);
   i=0;
   free(word);
  }
fin.close();

ifstream finn("telephone.dat");
string aaaa;
while(finn.good()) 
 {
  finn>>aaaa;
  finn>>aaaa;
  finn>>aaaa;
  word =(char *) calloc(40, sizeof(int));
   while((a=finn.get())!=',')
    {
     if(a!=' ')
      {
       word[i]=a;
       i++;
      }
    }
  key=t_key(word);
  laikinas=new struct rbTree;
  laikinas->desine=NULL;
  laikinas->kaire=NULL;
  laikinas->tevas=NULL;
  laikinas->spalva=0;
  laikinas->key=key;
  laikinas->name=word;
  laikinas->line=line;
  t_terpti(laikinas);
  line++;
  finn.getline(oneline,100);
  i=0;
  free(word);
 }
finn.close();

for(sk=1;sk<argc;sk++)
 {
  kazkas =argv[sk];
  skk=sk;
  if((strncmp(kazkas,sh,2)) == 0)
   h_ieskoti(hashas,argv[skk+1],didumas);
  if((strncmp(kazkas,st,2)) == 0)
   {
    i=t_key(argv[skk+1]);
    t_search(root,i,0);
   }
  if((strncmp(kazkas,ph,2)) == 0)
   {
    h_spausdinti(hashas,didumas);
   }
  if((strncmp(kazkas,pt,2)) == 0)
   inorder(root);
  if((strncmp(kazkas,ins,2))==0)
   {
    insert(argv[skk+1],didumas,linne,hashas,line);
    line++;
    linne++;
   }
  if((strncmp(kazkas,d,2)) == 0)
   h_trinti(hashas,argv[skk+1],didumas);
 }
}

//*****************************************
int h_key(char* wordas,int dydis)
{ 
 int i,ilgis,sk=0;
ilgis=strlen(wordas);
 for(i=0;i<=ilgis;i++)
  sk=sk+wordas[i];
 sk=sk/32;
 sk=sk%dydis;
 if(sk<0)
 sk=sk*-1;
 return sk; 
}
//*****************************
void h_terpti(struct hash **terpiam,int key,int line,std::string vardas)
{
   struct hash *temp=NULL;
   temp=new struct hash[sizeof(struct hash)];
   temp->line=line;
   temp->name=vardas;
   temp->kitas=terpiam[key];
   terpiam[key]=temp;
}
//****************************
void h_spausdinti(struct hash ** laikinas,int dydis)
{
 struct hash *temp=NULL;
 int i;
 for(i=0;i<dydis;i++)
  {
   temp=laikinas[i];
   cout<<i<<" |->";
   while(temp!=NULL)
    {
     cout<<temp->name<<" "<<temp->line<<" ";
     temp=temp->kitas;
    }
   cout<<endl;
  }
}
//**************************
void h_ieskoti(struct hash** laikinas,char* ieskomas,int dydis)
{
 int key,i=0;
 struct hash *temp=NULL;
 key=h_key(ieskomas,dydis);
 temp=laikinas[key];
 while(temp!=NULL)
  {
   if((temp->name)==(ieskomas))
    {
     f_eilute(temp->line);
     i++;
    }
   temp=temp->kitas;
  }
 if(i==0)
  cout<<"Pagal varda nieks nerastas, galima ivedimo klaida."<<endl;
}
//**************************
void f_eilute(int line)
{
 int i=1;
 char oneline[100];
 ifstream fin("telephone.dat");
 while(fin.good())
  {
   fin.getline(oneline,100);
   if(line == i)
   cout<<oneline<<endl;
   i++;
  }
fin.close();
}
//**************************
int t_key(char* wordas)
{ 
int i,ilgis,sk=0;
ilgis=strlen(wordas);
 for(i=0;i<=ilgis;i++)
  {
   sk=sk+wordas[i];
  }
 if(sk<0)
 sk=sk*-1;
 return sk; 
}
//****************************
void t_terpti(struct rbTree *temp)
{
 struct rbTree *x, *y;
 x=root;
 y=NULL;
 while (x!=NULL)
  {
   y = x;
   if((temp->key) <= (x->key))
    x=x->kaire;
   else 
    x=x->desine;
  }
temp->tevas=y;
if(y==NULL)
 root=temp;
else
 {
  temp->tevas=y;
  if(temp->key<=y->key)
   y->kaire = temp;
  else 
   y->desine = temp;
 }
t_sukeist(temp); 
}
//*****************************
void t_kairysPosukis(struct rbTree *x)
{
 struct rbTree *y = x->desine;
 x->desine=y->kaire;
 if(y->kaire!=NULL) 
  y->kaire->tevas=x;
 if(y!=NULL) 
  y->tevas=x->tevas;
 if(x->tevas)
  {
   if(x==x->tevas->kaire) 
    x->tevas->kaire=y;
   else 
    x->tevas->desine=y;
  } 
 else 
  root=y;
 y->kaire=x;
 if(x!=NULL)
  x->tevas=y;
}

void t_desinysPosukis(struct rbTree *x)
{
 struct rbTree *y = x->kaire;
 x->kaire = y->desine;
 if (y->desine != NULL) 
  y->desine->tevas = x;	
 if (y != NULL) 
  y->tevas = x->tevas;
 if (x->tevas)
  {
   if (x == x->tevas->desine) 
    x->tevas->desine = y;
   else 
    x->tevas->kaire = y;
    } 
    else root = y;
  
    y->desine = x;
    if(x!= NULL) 
     x->tevas=y;
}
void t_sukeist(struct rbTree *x)
{
struct rbTree *y;
while (x->tevas!=NULL && x->tevas->spalva==0)
 {
  if (x->tevas!=x->tevas->tevas->kaire)
   {
    y=x->tevas->tevas->kaire;
    if (y!=NULL)
     { 
      if (y->spalva==0)
       { 
        x->tevas->spalva=1;
        y->spalva=1;
        x->tevas->tevas->spalva=0;
        x=x->tevas->tevas;
       }
     } 
    else
     {
      if (x==x->tevas->kaire)
       {
        x=x->tevas;
        t_desinysPosukis(x);
       } 
      else
       {
        x->tevas->spalva=1;
        x->tevas->tevas->spalva=0;
        t_kairysPosukis(x->tevas->tevas);
       }
     }
   }
  else
   {
    y=x->tevas->tevas->desine;
    if (y!=NULL)
     {
      if (y->spalva==0)
       {
        x->tevas->spalva=1;
        y->spalva=1;
        x->tevas->tevas->spalva=0;
        x=x->tevas->tevas;
       }
     }
    else
     {
      if (x==x->tevas->desine)
       {
        x=x->tevas;
        t_kairysPosukis(x);
       }
      else
       {
        x->tevas->spalva=1;
        x->tevas->tevas->spalva=0;
        t_desinysPosukis(x->tevas->tevas);
       }
     }
   }
 } 
root->spalva=1;	
}
void inorder(struct rbTree *temp)
{ 
 int i;
 if (temp->kaire != NULL)
  inorder (temp->kaire);
 if(temp->line!=-1)
  {	
   i=temp->line;
   f_eilute(i);
  }
 if (temp->desine != NULL)
  inorder (temp->desine);
}
void t_search(struct rbTree *temp,int i,int z)
{
 if((temp==NULL))
  {
   if(z==0)
   cout<<"Pagal gatve nieks nerastas, galima klaida ivedime."<<endl;
   return ;
  }
 if(temp->key==i)
  {
   if(temp->line!=-1)
    f_eilute(temp->line);
   z++;
  }
 if(i<=temp->key)
  t_search(temp->kaire,i,z);
 else
  t_search(temp->desine,i,z);
}

int h_trinti(struct hash **laikinas,char *trinamas,int dydis)
{
 int key;
 struct hash *temp=NULL,*n=NULL;
 key=h_key(trinamas,dydis);
 temp=laikinas[key];
 if(temp==NULL)
  {
   cout<<"Nera ka trint"<<endl;
   return 0;
  }
   if((temp->name)==(trinamas))
    {
     laikinas[key]=temp->kitas;
     f_getgatve(temp->line);
     //if(temp!=NULL)
    // delete temp;
     //else cout<<"Labas"<<endl;
     return 0;
    }
   else cout<<"Nera ka trint"<<endl;
 if(temp->kitas==NULL)
  return 0;
 while((temp->kitas->name!=trinamas)&&(temp->kitas->kitas!=NULL))
  temp=temp->kitas;
 if(temp->kitas->name==trinamas)
  {
   n=temp->kitas->kitas;
   f_getgatve(temp->kitas->line);
   
   temp->kitas=n;
 //if(temp->kitas!=NULL)
  //delete temp->kitas;
 //else cout<<"Sveikas"<<endl;  
   return 0;
  }
}
void insert(char *eilute,int dydis,int hline,struct hash **hashas,int tline)
{
 int ilgis,k=0,z=0,i=0,n=0,kableliai=0;
 char *vardas,*gatve,*temp1,*temp2;
 struct rbTree *laikinas;
 ilgis=strlen(eilute);
 temp1  =(char *) calloc(40, sizeof(int));
 temp2  =(char *) calloc(40, sizeof(int));
for(i=0;i<=ilgis;i++)
 {
  if (eilute[i]==',')
   kableliai++;
  if((kableliai<1)&&(eilute[i]!=' '))
   {
    temp1[k]=eilute[i];
    k++;
   }
  if((kableliai==3)&&(eilute[i]!=' ')&&(eilute[i]!=','))
   {
    temp2[z]=eilute[i];
    z++;
   } 
 }
 n=h_key(temp1,dydis);
 h_terpti(hashas,n,hline,temp1);
 i=t_key(temp2);
 cout<<i<<endl;
 laikinas=new struct rbTree;
 laikinas->desine=NULL;
 laikinas->kaire=NULL;
 laikinas->tevas=NULL;
 laikinas->spalva=0;
 laikinas->key=i;
 laikinas->name=temp2;
 laikinas->line=tline;
 t_terpti(laikinas);
ofstream fiin;
fiin.open("telephone.dat",ofstream::app);
fiin<<endl<<eilute;
fiin.close(); 
}
void f_getgatve(int line)
{
 int i,z=0;
 char oneline[100],*word,a,*buffer;
 string aaaa;
 ifstream fin("telephone.dat");
 for(i=1;i<line;i++)
  {
   fin.getline(oneline,100);
  }
  fin>>aaaa;
  fin>>aaaa;
  fin>>aaaa;
  word =(char *) calloc(40, sizeof(int));
   while((a=fin.get())!=',')
    {
     if(a!=' ')
      {
       word[z]=a;
       z++;
      }
    }
i=t_key(word);
t_delete(root,i,line);

}
void t_delete(struct rbTree *temp,int key,int line)
{
 if((temp==NULL))
  {
   return ;
  }
 if(temp->key==key)
  {
   if(temp->line==line)
    {
     f_write(line);
     temp->line=-1;
    }
  }
 if(key<=temp->key)
  t_delete(temp->kaire,key,line);
 else
  t_delete(temp->desine,key,line);
}
void f_write(int line)
{
 int i=0;
 char oneline[100]; 
 ifstream fin("telephone.dat");
 ofstream foutemp("temp.txt");
 while(fin.good())
  {
   fin.getline(oneline,48);
   i++;
   if(i!=line)
    {
     foutemp.write(oneline,48);
     foutemp<<endl;
    }
   else
    foutemp<<endl;
  }
foutemp.close();
fin.close();
//i=0;
/*ifstream fiin("temp.txt");
ofstream fout("telephone.dat");
 while(fiin.good())
  {
   fiin.getline(oneline,48);
   i++;
   if(i!=line)
    {
     fout.write(oneline,48);
     fout<<endl;
    }
   else
    fout<<endl;
  }
fout.close();
fiin.close();
*/
}
